/* glib-2.0-win32.c
 * instead of glib-2.0.lib.
 *
 * Copyright (C) 2004 Oki Telecommunication Systems Co.,Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <glib.h>
#include <malloc.h>
#include <stdio.h>
#include <string.h>

#define BUF_MAX	1024
static FILE*	output = stdout;
static FILE*	error = stderr;
static char	buf[BUF_MAX];

//glib/gmem.h
gpointer g_malloc         (gulong	 n_bytes)
{
	return(malloc(n_bytes));
}

gpointer g_realloc        (gpointer	 mem,
			   gulong	 n_bytes)
{
	return(realloc(mem, n_bytes));
}

void	 g_free	          (gpointer	 mem)
{
	free(mem);
	return;
}

//glib/gstrfuncs.h
gchar*	              g_strdup	       (const gchar *str)
{
	return(strdup(str));
}

gchar*	              g_strdup_printf  (const gchar *format,
					...) G_GNUC_PRINTF (1, 2)
{
	va_list	ap;
	int		n;

	va_start(ap, format);
	n = vsprintf(buf, format, ap);
	va_end(ap);
	if(n < 0 || BUF_MAX <= n)
	{
		return(NULL);
	}
	return(strdup(buf));
}

//glib/gmassages.h
void            g_log                   (const gchar    *log_domain,
                                         GLogLevelFlags  log_level,
                                         const gchar    *format,
                                         ...) G_GNUC_PRINTF (3, 4)
{
	va_list	ap;
	int		n;

	fprintf(output, "domain = %s, level = %d, ", log_domain, log_level);
	va_start(ap, format);
	n = vsprintf(buf, format, ap);
	va_end(ap);
	if(n < 0 || BUF_MAX <= n)
	{
		fprintf(error, "log temporary buffer overflow(%d)!\n", n);
		return;
	}
	fprintf(error, buf);
	return;
}

void            g_logv                  (const gchar    *log_domain,
                                         GLogLevelFlags  log_level,
                                         const gchar    *format,
                                         va_list         args)
{
	int		n;

	fprintf(output, "domain = %s, level = %d, ", log_domain, log_level);
	n = vsprintf(buf, format, args);
	if(n < 0 || BUF_MAX <= n)
	{
		fprintf(error, "log temporary buffer overflow(%d)!\n", n);
		return;
	}
	fprintf(error, buf);
	return;
}
