/* packetDump.c
 *
 * Copyright (C) 2004 Oki Telecommunication Systems Co.,Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#include <wtap-int.h>
#include <wtap.h>
#include <windows.h>
#include "packetDump.h"

#define BUFFER_SIZE		(1024*1024)	//obt@TCYi1MBytesj
#define LIBPCAP_HEADER_SIZE	24		//libpcapt@Cwb_
int	dumpCaptureFile2(struct _T_PACKET_DUMP* ptPacketDump);

//Lv`t@C_v
__declspec(dllexport) long WINAPI
dumpCaptureFile(
	struct _T_PACKET_DUMP*	ptPacketDump	//pPbg_v\
)
{
	long				lrc;		//^R[h

#ifdef	NOUSE
{
	char	cBuf[2048];
	wsprintf(cBuf,
		"source ip:%08x, port:%04x, destination ip:%08x, port:%04x, protocol:%08x\n"
		"output folder:%s.\nbase file name:%s.capture file:%s.\n",
		ptPacketDump->ulSourceIP,
		ptPacketDump->usSourcePort,
		ptPacketDump->ulDestinationIP,
		ptPacketDump->usDestinationPort,
		ptPacketDump->ulPortocol,
		ptPacketDump->cCaptureFilename,
		ptPacketDump->cOutputFoldername,
		ptPacketDump->cBaseFilename);
	MessageBox(NULL, cBuf, "packetDump", 0);
}
#endif	//NOUSE
	if(MAX_PATH < strlen(ptPacketDump->cOutputFoldername) + strlen(ptPacketDump->cBaseFilename) + strlen("-0000.dat") + 1)
	{
		return(ERROR_OUTPUTFILENAME_TOO_LONG);
	}
	lrc = dumpCaptureFile2(ptPacketDump);
	return(lrc);
}

//Lv`t@CJ
__declspec(dllexport) long WINAPI
freeCaptureFile(
	struct _T_PACKET_DUMP*	ptPacketDump	//pPbg_v\
)
{
	struct _T_PACKET_DUMP_LIST*	ptPacketDumpList;
	struct _T_PACKET_DUMP_LIST*	ptPacketDumpListNext;

	for(ptPacketDumpList = ptPacketDump->ptPacketDumpList; ptPacketDumpList != NULL; )
	{
		ptPacketDumpListNext = ptPacketDumpList->ptPacketDumpListNext;
		free(ptPacketDumpList);
		ptPacketDumpList = ptPacketDumpListNext;
	}
	ptPacketDump->ptPacketDumpList = NULL;
	return(ERROR_NONE);
}
