/* zdll-win32.c
 * instead of zdll.lib.
 *
 * Copyright (C) 2004 Oki Telecommunication Systems Co.,Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <errno.h>
#include <stdio.h>
#include "wtap-int.h"

#define BUF_MAX	1024
static FILE*	output = stdout;
static FILE*	error = stderr;
static char	buf[BUF_MAX];

//typedef voidp gzFile;
ZEXTERN gzFile ZEXPORT gzopen  (const char *path, const char *mode)
{
	return((gzFile)fopen(path, mode));
}

ZEXTERN gzFile ZEXPORT gzdopen  (int fd, const char *mode)
{
	return((gzFile)fdopen(fd, mode));
}

ZEXTERN int ZEXPORT    gzread  (gzFile file, voidp buf, unsigned len)
{
	return(fread(buf, 1, len, file));
}

ZEXTERN int ZEXPORTVA   gzprintf (gzFile file, const char *format, ...)
{
	va_list	ap;
	int		n;

	va_start(ap, format);
	n = vsprintf(buf, format, ap);
	va_end(ap);
	if(n < 0 || BUF_MAX <= n)
	{	//error occured
	}
	else
	{	//normal end
		fprintf(output, buf);
	}
	return(n);
}

ZEXTERN z_off_t ZEXPORT    gzseek (gzFile file,
                                      z_off_t offset, int whence)
{
	return(fseek(file, offset, whence));
}

ZEXTERN z_off_t ZEXPORT    gztell (gzFile file)
{
	return(ftell(file));
}

ZEXTERN int ZEXPORT    gzclose (gzFile file)
{
	return(fclose(file));
}

ZEXTERN const char * ZEXPORT gzerror (gzFile file, int *errnum)
{
	*errnum = ferror((FILE*)file);
	return(NULL);
}
